CREATE TABLE HCL 
    ( 
     HCL_ID NUMBER (18)  NOT NULL 
    ) LOGGING 
;



ALTER TABLE HCL 
    ADD CONSTRAINT HCL_PK PRIMARY KEY ( HCL_ID ) 
;



CREATE TABLE HCL_CODE 
    ( 
     HCODE_ID NUMBER (18)  NOT NULL , 
     PARENT_HCODE_ID NUMBER (18) , 
     LCD_ID NUMBER (18)  NOT NULL , 
     H_ID NUMBER (18)  NOT NULL , 
     LEVEL_ID NUMBER (18) 
    ) LOGGING 
;



ALTER TABLE HCL_CODE 
    ADD CONSTRAINT HCL_CODE_PK PRIMARY KEY ( HCODE_ID ) 
;



CREATE TABLE HIERARCHY 
    ( 
     H_ID NUMBER (18)  NOT NULL , 
     HCL_ID NUMBER (18)  NOT NULL 
    ) LOGGING 
;



ALTER TABLE HIERARCHY 
    ADD CONSTRAINT HIERARCHY_PK PRIMARY KEY ( H_ID ) 
;



CREATE TABLE HLEVEL 
    ( 
     LEVEL_ID NUMBER (18)  NOT NULL , 
     H_ID NUMBER (18)  NOT NULL , 
     PARENT_LEVEL_ID NUMBER (18) 
    ) LOGGING 
;



ALTER TABLE HLEVEL 
    ADD CONSTRAINT LEVEL_PK PRIMARY KEY ( LEVEL_ID ) 
;




ALTER TABLE HCL 
    ADD CONSTRAINT HCL_ARTEFACT_FK FOREIGN KEY 
    ( 
     HCL_ID
    ) 
    REFERENCES ARTEFACT 
    ( 
     ART_ID
    ) 
    ON DELETE CASCADE 
    NOT DEFERRABLE 
;


ALTER TABLE HCL_CODE 
    ADD CONSTRAINT HCL_CODE_ARTEFACT_FK FOREIGN KEY 
    ( 
     HCODE_ID
    ) 
    REFERENCES ARTEFACT 
    ( 
     ART_ID
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE HCL_CODE 
    ADD CONSTRAINT HCL_CODE_DSD_CODE_FK FOREIGN KEY 
    ( 
     LCD_ID
    ) 
    REFERENCES DSD_CODE 
    ( 
     LCD_ID
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE HCL_CODE 
    ADD CONSTRAINT HCL_CODE_HCL_CODE_FK FOREIGN KEY 
    ( 
     PARENT_HCODE_ID
    ) 
    REFERENCES HCL_CODE 
    ( 
     HCODE_ID
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE HCL_CODE 
    ADD CONSTRAINT HCL_CODE_HIERARCHY_FK FOREIGN KEY 
    ( 
     H_ID
    ) 
    REFERENCES HIERARCHY 
    ( 
     H_ID
    ) 
    ON DELETE CASCADE 
    NOT DEFERRABLE 
;


ALTER TABLE HCL_CODE 
    ADD CONSTRAINT HCL_CODE_LEVEL_FK FOREIGN KEY 
    ( 
     LEVEL_ID
    ) 
    REFERENCES HLEVEL 
    ( 
     LEVEL_ID
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE HIERARCHY 
    ADD CONSTRAINT HIERARCHY_ARTEFACT_FK FOREIGN KEY 
    ( 
     H_ID
    ) 
    REFERENCES ARTEFACT 
    ( 
     ART_ID
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE HIERARCHY 
    ADD CONSTRAINT HIERARCHY_HCL_FK FOREIGN KEY 
    ( 
     HCL_ID
    ) 
    REFERENCES HCL 
    ( 
     HCL_ID
    ) 
    ON DELETE CASCADE 
    NOT DEFERRABLE 
;


ALTER TABLE HLEVEL 
    ADD CONSTRAINT LEVEL_ARTEFACT_FK FOREIGN KEY 
    ( 
     LEVEL_ID
    ) 
    REFERENCES ARTEFACT 
    ( 
     ART_ID
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE HLEVEL 
    ADD CONSTRAINT LEVEL_HIERARCHY_FK FOREIGN KEY 
    ( 
     H_ID
    ) 
    REFERENCES HIERARCHY 
    ( 
     H_ID
    ) 
    ON DELETE CASCADE 
    NOT DEFERRABLE 
;


ALTER TABLE HLEVEL 
    ADD CONSTRAINT LEVEL_LEVEL_FK FOREIGN KEY 
    ( 
     PARENT_LEVEL_ID
    ) 
    REFERENCES HLEVEL 
    ( 
     LEVEL_ID
    ) 
    NOT DEFERRABLE 
;


ALTER TABLE ARTEFACT ADD VALID_FROM VARCHAR2(50) NULL
;

ALTER TABLE ARTEFACT ADD VALID_TO VARCHAR2(50) NULL
;

update DB_VERSION SET VERSION = '2.5'
;

ALTER TABLE ARTEFACT MODIFY (ID VARCHAR2(50) NULL)
;

ALTER TABLE ARTEFACT MODIFY (AGENCY VARCHAR2(50) NULL)
;
